Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class CellRendererPane

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.CellRendererPane

public class CellRendererPane
extends java.awt.Container
implements Accessible

This class is inserted in between cell renderers and the components that use them. It just exists to thwart the repaint() and invalidate() methods which would otherwise propogate up the tree when the renderer was configured. It's used by the implementations of JTable, JTree, and JList. For example, here's how CellRendererPane is used in the code the paints each row in a JList:

       cellRendererPane = new CellRendererPane();
       ...
       Component rendererComponent = renderer.getListCellRendererComponent();
       renderer.configureListCellRenderer(dataModel.getElementAt(row), row);
       cellRendererPane.paintComponent(g, rendererComponent, this, x, y, w, h);

A renderer component must override isShowing() and unconditionally return true to work correctly because the Swing paint does nothing for components with isShowing false.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  Serialized Form

Inner Class Summary
`protected class` | `CellRendererPane.AccessibleCellRendererPane`

Field Summary
`protected AccessibleContext` | `accessibleContext`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`CellRendererPane()` Construct a CellRendererPane object.

Method Summary
`protected void` | `addImpl(java.awt.Component x, java.lang.Object constraints, int index)` If the specified component is already a child of this then we don't bother doing anything - stacking order doesn't matter for cell renderer components (CellRendererPane doesn't paint anyway).<
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this CellRendererPane
`void` | `invalidate()` Overridden to avoid propogating a invalidate up the tree when the cell renderer child is configured.
`void` | `paint(java.awt.Graphics g)` Shouldn't be called.
`void` | `paintComponent(java.awt.Graphics g, java.awt.Component c, java.awt.Container p, int x, int y, int w, int h)` Calls this.paintComponent(g, c, p, x, y, w, h, false).
`void` | `paintComponent(java.awt.Graphics g, java.awt.Component c, java.awt.Container p, int x, int y, int w, int h, boolean shouldValidate)` Paint a cell renderer component c on graphics object g.
`void` | `paintComponent(java.awt.Graphics g, java.awt.Component c, java.awt.Container p, java.awt.Rectangle r)` Calls this.paintComponent() with the rectangles x,y,width,height fields.
`void` | `update(java.awt.Graphics g)` Shouldn't be called.

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addNotify, countComponents, deliverEvent, doLayout, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getInsets, getLayout, getMaximumSize, getMinimumSize, getPreferredSize, insets, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, paramString, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, removeNotify, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getGraphics, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isFocusTraversable, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, repaint, requestFocus, reshape, resize, resize, setBackground, setBounds, setBounds, setCursor, setEnabled, setFont, setForeground, setLocale, setLocation, setLocation, setName, setSize, setSize, setVisible, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### accessibleContext

    protected AccessibleContext accessibleContext

Constructor Detail

### CellRendererPane

    public CellRendererPane()

  Construct a CellRendererPane object.

Method Detail

### invalidate

    public void invalidate()

  Overridden to avoid propogating a invalidate up the tree when the cell renderer child is configured.
  Overrides:
    invalidate in class java.awt.Container

### paint

    public void paint(java.awt.Graphics g)

  Shouldn't be called.
  Overrides:
    paint in class java.awt.Container

### update

    public void update(java.awt.Graphics g)

  Shouldn't be called.
  Overrides:
    update in class java.awt.Container

### addImpl

    protected void addImpl(java.awt.Component x,
                           java.lang.Object constraints,
                           int index)

  If the specified component is already a child of this then we don't bother doing anything - stacking order doesn't matter for cell renderer components (CellRendererPane doesn't paint anyway).<
  Overrides:
    addImpl in class java.awt.Container

### paintComponent

    public void paintComponent(java.awt.Graphics g,
                               java.awt.Component c,
                               java.awt.Container p,
                               int x,
                               int y,
                               int w,
                               int h,
                               boolean shouldValidate)

  Paint a cell renderer component c on graphics object g. Before the component is drawn it's reparented to this (if that's neccessary), it's bounds are set to w,h and the graphics object is (effectively) translated to x,y. If it's a JComponent, double buffering is temporarily turned off. After the component is painted it's bounds are reset to -w, -h, 0, 0 so that, if it's the last renderer component painted, it will not start consuming input. The Container p is the component we're actually drawing on, typically it's equal to this.getParent(). If shouldValidate is true the component c will be validated before painted.

### paintComponent

    public void paintComponent(java.awt.Graphics g,
                               java.awt.Component c,
                               java.awt.Container p,
                               int x,
                               int y,
                               int w,
                               int h)

  Calls this.paintComponent(g, c, p, x, y, w, h, false).

### paintComponent

    public void paintComponent(java.awt.Graphics g,
                               java.awt.Component c,
                               java.awt.Container p,
                               java.awt.Rectangle r)

  Calls this.paintComponent() with the rectangles x,y,width,height fields.

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this CellRendererPane
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this CellRendererPane

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.